package com.elmakers.mine.bukkit.data;

import java.util.logging.Logger;

/**
 * Represents a single field in a data row.
 * 
 * @author NathanWolf
 * 
 */
public class DataField
{
    protected static Logger log = DataStore.getLogger();

    protected boolean       autogenerate;

    protected boolean       idField;

    protected String        name;

    protected DataType      type;

    protected Object        value;

    public DataField()
    {
    }

    public DataField(Object value)
    {
        this.value = value;
    }

    public DataField(String name, DataType type)
    {
        this.name = name;
        this.type = type;
    }

    public DataField(String name, DataType type, Object value)
    {
        this.name = name;
        this.type = type;
        this.value = value;
    }

    public String getName()
    {
        return name;
    }

    public DataType getType()
    {
        return type;
    }

    public Object getValue()
    {
        return value;
    }

    public Object getValue(Class<?> targetClass)
    {
        return DataType.convertValue(value, targetClass);
    }

    public boolean isAutogenerated()
    {
        return autogenerate;
    }

    public boolean isIdField()
    {
        return idField;
    }

    public void setAutogenerated(boolean autogenerate)
    {
        this.autogenerate = autogenerate;
    }

    public void setIdField(boolean id)
    {
        idField = id;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public void setType(DataType type)
    {
        this.type = type;
    }

    public void setValue(Object value)
    {
        this.value = value;
        if (type == null)
        {
            type = DataType.getTypeFromClass(value.getClass());
        }
    }
}
